#include <stdio.h>
#include <netinet/in.h>
#include "bios.h"
#include "initcmds.h"
#include "parser.h"

void init_io_restrict_prog(bios_t *bios, unsigned int offset) {

}

void init_repeat(bios_t *bios, unsigned int offset) {

}

void init_end_repeat(bios_t *bios, unsigned int offset) {

}

void init_copy(bios_t *bios, unsigned int offset) {

}

void init_not(bios_t *bios, unsigned int offset) {

}
/*
void cmd0x39(bios_t *bios, unsigned int offset) {

}
*/
void init_io_restrict_pll(bios_t *bios, unsigned int offset) {

}

void init_pll(bios_t *bios, unsigned int offset) {

}

void init_cr_idx_adr_latch(bios_t *bios, unsigned int offset) {

}

void init_cr(bios_t *bios, unsigned int offset) {

}

void init_zm_cr(bios_t *bios, unsigned int offset) {

}

void init_zm_cr_group(bios_t *bios, unsigned int offset) {

}

void init_condition_time(bios_t *bios, unsigned int offset) {

}

void init_zm_reg_sequence(bios_t *bios, unsigned int offset) {

}

void init_sub_direct(bios_t *bios, unsigned int offset) {
    uint16_t sub_offset = *((uint16_t *) (&bios->data[offset]));
    
    DEBUGPRINT(5, "%04X: Executing sub-routine at: 0x%04X\n", offset - 1, sub_offset);
    parse_init_table(bios, sub_offset);
}

void init_copy_nv_reg(bios_t *bios, unsigned int offset) {

}

void init_zm_index_io(bios_t *bios, unsigned int offset) {

}

void init_compute_mem(bios_t *bios, unsigned int offset) {

}

void init_reset(bios_t *bios, unsigned int offset) {

}

void init_sub(bios_t *bios, unsigned int offset) {

}

void init_nv_reg(bios_t *bios, unsigned int offset) {
    uint32_t reg = *((uint32_t *) (&bios->data[offset]));
    uint32_t and = *((uint32_t *) (&bios->data[offset + 4]));
    uint32_t or = *((uint32_t *) (&bios->data[offset + 8]));
    uint32_t data;

    DEBUGPRINT(5, "%04X: REG: 0x%08X, AND: 0x%08X, OR: 0x%08X\n", offset - 1,
            reg, and, or);
}

void init_macro(bios_t *bios, unsigned int offset) {
    
    uint32_t macro = *((uint32_t *) (&bios->data[offset + 1]));
    DEBUGPRINT(5, "Executing macro: 0x%02X\n", macro);
}

void init_done(bios_t *bios, unsigned int offset) {

}

void init_resume(bios_t *bios, unsigned int offset) {

}

void init_time(bios_t *bios, unsigned int offset) {

}

void init_condition(bios_t *bios, unsigned int offset) {

}

void init_index_io(bios_t *bios, unsigned int offset) {
    uint16_t reg = *((uint16_t *) (&bios->data[offset]));
    uint8_t index = *((uint8_t *) (&bios->data[offset + 2]));
    uint8_t and  = *((uint8_t *) (&bios->data[offset + 3]));
    uint8_t or = *((uint8_t *) (&bios->data[offset + 4]));
    
    DEBUGPRINT(5, "cmd 'RD idx ISA reg $%02x via $%04x, AND-out = $%02x, OR-in = $%02x, WR-bk'\n", index, reg, and, or);
    

}

void init_zm_reg(bios_t *bios, unsigned int offset) {
    uint32_t reg = *((uint32_t *) (&bios->data[offset]));
    uint32_t value = *((uint32_t *) (&bios->data[offset + 4]));

    DEBUGPRINT(5, "%04X: REG: 0x%08X, VALUE: 0x%08X\n", offset - 1, reg, value);
    
    /* Assign: reg = value */
}

#if 0
static status_t translate_ISA_PCI(uint32* reg) {

    switch (*reg) {
        case 0x03c0:
            *reg = NV8_ATTRDATW;
            break;
        case 0x03c1:
            *reg = NV8_ATTRDATR;
            break;
        case 0x03c2:
            *reg = NV8_MISCW;
            break;
        case 0x03c4:
            *reg = NV8_SEQIND;
            break;
        case 0x03c5:
            *reg = NV8_SEQDAT;
            break;
        case 0x03c6:
            *reg = NV8_PALMASK;
            break;
        case 0x03c7:
            *reg = NV8_PALINDR;
            break;
        case 0x03c8:
            *reg = NV8_PALINDW;
            break;
        case 0x03c9:
            *reg = NV8_PALDATA;
            break;
        case 0x03cc:
            *reg = NV8_MISCR;
            break;
        case 0x03ce:
            *reg = NV8_GRPHIND;
            break;
        case 0x03cf:
            *reg = NV8_GRPHDAT;
            break;
        case 0x03d4:
            *reg = NV8_CRTCIND;
            break;
        case 0x03d5:
            *reg = NV8_CRTCDAT;
            break;
        case 0x03da:
            *reg = NV8_INSTAT1;
            break;
        default:
            DEBUGPRINT(5,"WARNING: ISA->PCI register adress translation failed!\n");
            return B_ERROR;
            break;
    }

    return B_OK;
}
#if 0
