#include "nvsoftboot.h"

/*
typedef enum {
    EXECUTE, 
    SKIP
} execmode_t;
*/
typedef struct {
    bool_t execute;
    bool_t repeat;
} init_exec_t;


#define VARIABLE -1

typedef struct {
    unsigned char *data;
    unsigned int  length;
    
    uint16_t      init_tbls_offset;
    uint16_t      ram_table_offset;    
    uint16_t      macro_offset; 
    uint16_t      condition_offset;
    uint16_t      io_flag_condition_offset;
} bios_t;

typedef struct {
    char *name;
    unsigned char id;
    int length;
    bool_t (*handler)(bios_t *, uint16_t, init_exec_t *);
    int used; /* FIXME: temp */
} init_tbl_entry_t;

typedef struct {
    unsigned char id[2];
    unsigned short length;
    unsigned short offset;
} bit_entry_t;

