#include "nvsoftboot.h"

#define MACRO_SIZE              8
#define CONDITION_SIZE          12
#define IO_FLAG_CONDITION_SIZE  9 

bool_t init_io_restrict_prog(bios_t *bios, uint16_t offset, init_exec_t *iexec);
bool_t init_repeat(bios_t *bios, uint16_t offset, init_exec_t *iexec);
bool_t init_end_repeat(bios_t *bios, uint16_t offset, init_exec_t *iexec);
bool_t init_copy(bios_t *bios, uint16_t offset, init_exec_t *iexec);
bool_t init_not(bios_t *bios, uint16_t offset, init_exec_t *iexec);
bool_t init_io_flag_condition(bios_t *bios, uint16_t offset, init_exec_t *iexec);
bool_t init_io_restrict_pll(bios_t *bios, uint16_t offset, init_exec_t *iexec);
bool_t init_pll(bios_t *bios, uint16_t offset, init_exec_t *iexec);
bool_t init_cr_idx_adr_latch(bios_t *bios, uint16_t offset, init_exec_t *iexec);
bool_t init_cr(bios_t *bios, uint16_t offset, init_exec_t *iexec);
bool_t init_zm_cr(bios_t *bios, uint16_t offset, init_exec_t *iexec);
bool_t init_zm_cr_group(bios_t *bios, uint16_t offset, init_exec_t *iexec);
bool_t init_condition_time(bios_t *bios, uint16_t offset, init_exec_t *iexec);
bool_t init_zm_reg_sequence(bios_t *bios, uint16_t offset, init_exec_t *iexec);
bool_t init_sub_direct(bios_t *bios, uint16_t offset, init_exec_t *iexec);
bool_t init_copy_nv_reg(bios_t *bios, uint16_t offset, init_exec_t *iexec);
bool_t init_zm_index_io(bios_t *bios, uint16_t offset, init_exec_t *iexec);
bool_t init_compute_mem(bios_t *bios, uint16_t offset, init_exec_t *iexec);
bool_t init_reset(bios_t *bios, uint16_t offset, init_exec_t *iexec);
bool_t init_sub(bios_t *bios, uint16_t offset, init_exec_t *iexec);
bool_t init_nv_reg(bios_t *bios, uint16_t offset, init_exec_t *iexec);
bool_t init_macro(bios_t *bios, uint16_t offset, init_exec_t *iexec);
bool_t init_done(bios_t *bios, uint16_t offset, init_exec_t *iexec);
bool_t init_resume(bios_t *bios, uint16_t offset, init_exec_t *iexec);
bool_t init_time(bios_t *bios, uint16_t offset, init_exec_t *iexec);
bool_t init_condition(bios_t *bios, uint16_t offset, init_exec_t *iexec);
bool_t init_index_io(bios_t *bios, uint16_t offset, init_exec_t *iexec);
bool_t init_zm_reg(bios_t *bios, uint16_t offset, init_exec_t *iexec);



uint32_t regvalue(uint32_t reg);

