#ifndef _NVSOFTBOOT_H
#define _NVSOFTBOOT_H

#include <netinet/in.h>


#ifndef DEBUGLEVEL
#define DEBUGLEVEL 6
#endif

#define DEBUGPRINT(level, text, ...) \
if (level <= DEBUGLEVEL) \
    printf("(%d): " text, level, ## __VA_ARGS__) \


typedef char status_t;

#define SUCCESS 1
#define FAILURE 0

typedef char bool_t;

#define TRUE 1
#define FALSE 0

#endif

